/* DfsTagBlockFloatEnd.h */
/* Managenet of tag at the end of DFS File (tag which are modified) */

#if defined(__cplusplus) && (!defined(ALLINCPP))
extern "C" {
#endif

DECLARE_DFHANDLE(DFTAGBLOCKFLOAT);

#define FLOATNUM_NOSPECIFIC (0xffffffff)

DFTAGBLOCKFLOAT SVFAPI BuildEmptyBlockFloat();

DFTAGBLOCKFLOAT SVFAPI ReadDfTagBlockFloat(dfvoidp ptr, dfuLong32 * pTagListPackedSize);

DFTAGBLOCKFLOAT SVFAPI ReadDfTagBlockFloatSizeLimited(dfvoidp ptr, dfuLong32 * pTagListPackedSize, dfuLong32 dfLimit);

BOOL SVFAPI FlushTagBlockFloat(DFTAGBLOCKFLOAT TagBlockFloat, dfvoidp * ptr, dfuLong32 * size, BOOL compressed);

BOOL SVFAPI FreeFlushTagBlockFloatPtr(dfvoidp ptr);

BOOL SVFAPI CloseDfTagBlockFloat(DFTAGBLOCKFLOAT);


BOOL SVFAPI AddTagBlockFloat(DFTAGBLOCKFLOAT TagBlockFloat, dfuLong32 dfDirNum, 
                             dfuLong32 dfFileNum, 
                             dfuLong32 TagNumber, dfvoidpc TagBuf, dfuLong32 TagSize);

BOOL SVFAPI AddTaguLongBlockFloat(DFTAGBLOCKFLOAT TagBlockFloat, 
                                  dfuLong32 dfDirNum, dfuLong32 dfFileNum, dfuLong32 TagNumber, dfuLong32 value);


BOOL SVFAPI GetTagBlockFloat(DFTAGBLOCKFLOAT TagBlockFloat, 
                             dfuLong32 dfDirNum, dfuLong32 dfFileNum, dfuLong32 TagNumber, dfvoidp * pTagBuf,
                             dfuLong32 * pTagSize);

BOOL SVFAPI GetTaguLongBlockFloat(DFTAGBLOCKFLOAT TagBlockFloat, dfuLong32 dfDirNum, dfuLong32 dfFileNum, dfuLong32 TagNumber, dfuLong32 * value);

BOOL SVFAPI RemoveTagBlockFloat(DFTAGBLOCKFLOAT TagBlockFloat, dfuLong32 dfDirNum, dfuLong32 dfFileNum, dfuLong32 TagNumber);

BOOL SVFAPI DuplicateTagBlockFloatRange(DFTAGBLOCKFLOAT TagBlockFloatSrc, dfuLong32 dfDirNumSrc, dfuLong32 dfFileNumSrc,
                                 DFTAGBLOCKFLOAT TagBlockFloatDst, dfuLong32 dfDirNumDst, dfuLong32 dfFileNumDst,
                                 dfuLong32 TagNumberFirst,
                                 dfuLong32 TagNumberLast);

#if defined(__cplusplus) && (!defined(ALLINCPP))
}
#endif
