/* ReMixDfs.h */
/* Modify version in a Dfs */



#ifdef __cplusplus
extern "C" {
#endif


/*

typedef struct
{
  dfwcharpc filename_tostore;
  dfwcharpc filename_ondisk;
  dfwcharpc filename_prevversionondisk;
  dfuLong32   dfPreviousVersionFilePosition;
  BOOL      fIgnore;

  BOOL      fForceRecopyPrevious;
  BOOL      fForceDate;
  BOOL      fAddNewTag; // to be used later
  DFSINFODATE dfsInfoDate;
  dfvoidp   pReserved;

  dfuLong32   dfPreviousForceRecopySize;
  dfuLong32   dfPreviousForceRecopyCrc32;
}
FILETOADD_dfswrset.h;

*/

typedef struct
{
    dfwcharpc filename_tostore;
    dfwcharpc filename_ondisk;
    dfuLong32   dfPreviousVersionFilePositionItem; /* can be FTCI_REFERENCE_INDEPENDANT */
    BOOL      fIsReferenceInFileToAdd;

    BOOL      fForceRecopyPrevious;
    BOOL      fForceDate;
    BOOL      fAddNewTag; // to be used later
    DFSINFODATE dfsInfoDate;
    dfvoidp   pReserved;

    dfuLong32   dfPreviousForceRecopySize;
    dfuLong32   dfPreviousForceRecopyCrc32;
} FILETOADD_REMIX;

typedef struct
{
    dfuLong32 dfReferenceItem;
    BOOL fIsReferenceInAddedFile;
} FILETOCOPYINFO_REMIX ;

#define FTCI_REFERENCE_DELETE       ((dfuLong32)(0xffffffffUL))
#define FTCI_REFERENCE_UNMODIFIED   ((dfuLong32)(0xfffffffeUL))
#define FTCI_REFERENCE_INDEPENDANT  ((dfuLong32)(0xfffffffdUL))
#define FTCI_REFERENCE_JOKERBASE    ((dfuLong32)(0xfffffff0UL))

typedef struct
{
    dfuLong32 dfNumVersionPreviousSvf;

    dfuLong32 dfNbPreviousFileInMask;
    FILETOCOPYINFO_REMIX* pFileCopyInfo;

    dfuLong32 dfNbFileToAdd;
    FILETOADD_REMIX * pfta;
} VERSIONTOADD_REMIX;

/*
typedef struct
{
  dfuLong32 dfNbVersionToAdd;
  VERSIONTOADD_REMIX* pVersionToAdd;
} FRAMEWORK_REMIX;
*/

/*


BOOL SVFAPI DoGenerateSubDfs(DFSFILE DfsFileRead,PDIRINFO* pDirInfo,
                      DFSFILE *pDfsFileWrite,dfwcharpc dfWritingDfsFileName, // BOOL fZipFile,
                      const DFSFEATUREPARAM* pFeatureParam,
                      BOOL fBaseDirectorySelected,dfuLong32 dfBaseDirNum,dfwcharpc wchBaseDirectory,
                      dfuLong32 dwNbMapVersionMap,BOOL* lpVersionMap,
                      BOOL fFirstVersionAsReference,BOOL fReuseOldPatch, // future
                      const COMPRESSIONPARAM* pCprParam,
                      tSetExtractPosCallBack pSetExtractPosCallBack,dfvoidp dfUserPtr,
                      dfuLong32 dwMinProgress,dfuLong32 dwMaxProgress);
*/

BOOL SVFAPI DoGenerateSubDfsEmul(DFSFILE DfsFileRead,/*dfuLong32 dfNbDir,*/PDIRINFO* pDirInfo,
                      DFSFILE *pDfsFileWrite,dfwcharpc dfWritingDfsFileName, /*BOOL fZipFile,*/
                      const DFSFEATUREPARAM* pFeatureParam,
                      BOOL fBaseDirectorySelected,dfuLong32 dfBaseDirNum,dfwcharpc wchBaseDirectory,
                      const FILESET* pFileSetBase,
                      dfuLong32 dwNbMapVersionMap,const BOOL* lpVersionMap,
                      BOOL fFirstVersionAsReference,BOOL fReuseOldPatch /* future*/,
                      const COMPRESSIONPARAM* pCprParam,
                      tSetExtractPosCallBack pSetExtractPosCallBack,dfvoidp dfUserPtr,
                      dfuLong32 dwMinProgress,dfuLong32 dwMaxProgress,
                      H_ERROR_INFO* pei);


BOOL SVFAPI DoGenerateSubDfsEmulEx(DFSFILE DfsFileRead,/*dfuLong32 dfNbDir,*/PDIRINFO* pDirInfo,
                      DFSFILE *pDfsFileWrite,dfwcharpc dfWritingDfsFileName, /*BOOL fZipFile,*/
                      const DFSFEATUREPARAM* pFeatureParam,
                      BOOL fBaseDirectorySelected,dfuLong32 dfBaseDirNum,dfwcharpc wchBaseDirectory,
                      const FILESET* pFileSetBase,
                      dfuLong32 dwNbMapVersionMap,const BOOL* lpVersionMap,
                      BOOL fFirstVersionAsReference,BOOL fReuseOldPatch, BOOL fRawAccepted,
                      const COMPRESSIONPARAM* pCprParam,
                      tSetExtractPosCallBack pSetExtractPosCallBack,dfvoidp dfUserPtr,
                      dfuLong32 dwMinProgress,dfuLong32 dwMaxProgress,
                      H_ERROR_INFO* pei);


dfuLong32 SVFAPI DoReMixDfs(DFSFILE DfsFileRead,dfuLong32 dfNbDirDfsRead,const PCDIRINFO* pDirInfo,
                DFSFILE *pDfsFileWrite,dfwcharpc dfWritingDfsFileName, // BOOL fZipFile,
                const DFSFEATUREPARAM* pFeatureParam,
                BOOL fBaseDirectorySelected,dfuLong32 dfBaseDirNum,dfwcharpc wchBaseDirectory,
                const FILESET* pFileSetBase,
                dfuLong32 dfNbVersionRemix, const VERSIONTOADD_REMIX * pVersionRemix,
                BOOL fFirstVersionAsReference,BOOL fReuseOldPatch, // future
                const COMPRESSIONPARAM* pCprParam,
                tSetExtractPosCallBack pSetExtractPosCallBack,dfvoidp dfUserPtr,
                dfuLong32 dwMinProgress,dfuLong32 dwMaxProgress,H_ERROR_INFO* pei);

dfuLong32 SVFAPI DoReMixDfsEx(DFSFILE DfsFileRead, dfuLong32 dfNbDirDfsRead,
                const PCDIRINFO * pDirInfo, DFSFILE * pDfsFileWrite,
                dfwcharpc dfWritingDfsFileName,        // BOOL fZipFile,
                const DFSFEATUREPARAM* pFeatureParam,
                BOOL fBaseDirectorySelected, dfuLong32 dfBaseDirNum,
                dfwcharpc wchBaseDirectory,
                const FILESET* pFileSetBase,
                dfuLong32 dfNbVersionRemix,
                const VERSIONTOADD_REMIX * pVersionRemix,
				BOOL fFirstVersionAsReferenceNewDfs, BOOL fReuseOldPatch, BOOL fRawAccepted,
                const COMPRESSIONPARAM * pCprParam,
                tSetExtractPosCallBack pSetExtractPosCallBack,
                dfvoidp dfUserPtr, dfuLong32 dwMinProgress, dfuLong32 dwMaxProgress,
                H_ERROR_INFO* pei);

#ifdef __cplusplus
}
#endif
