/* dfsSet.h */
/* define callback used during work on SVF file */

#define TYPEDIR_FILECRCONLY             (1)
#define TYPEDIR_FILEINSERTING_STORE     (2)
#define TYPEDIR_FILEINSERTING_DEFLATE   (3)
#define TYPEDIR_PATCHFROMPREVIOUS       (4)


typedef struct
{
  dfuLong32 dfSizeStruct;
  DFSFILE DfsFile;

  dfuLong32 dfEvent;
  dfvoidp dfDataEventPtr;
  dfvoidp dfUserPtr;
  dfvoidp dfReserved;

  dfuLong32 dfDirType;
  BOOL fWillIgnoreFile;         // for DFCBM_BEFOREOPENPREVIOUSFILE
  dfwcharpc filename_onwork;
  dfwcharpc filename_previousversion;

  dfwcharpc filename_stored;
  BOOL fTemporaryFilename ;

  dfuLong64 dfDirOrigDone;
  dfuLong64 dfDirEncodedDone;
  dfuLong64 dfDirOrigSize;    // not alway filles
  dfuLong64 dfDirEncodedSize; // not alway filles
  dfuLong32 dfFileNumber;
  dfuLong64 dfFileOrigDone;
  dfuLong64 dfFileEncodedDone;
  dfuLong64 dfFileOrigSize;
  dfuLong64 dfFileEncodedSize;
}
PROGRESSCALLBACKINFO;

typedef BOOL(DFSCALLBACK * tProgressCallBack) (PROGRESSCALLBACKINFO *
                                               pProgressCallBackInfo);




#define DFCBM_BEFOREOPENDIRECTORY           (0x00000001)
#define DFCBM_AFTEROPENDIRECTORY            (0x00000011)
#define DFCBM_BEFOREOPENPREVIOUSFILE        (0x00000002)
#define DFCBM_BEFOREOPENWORKINGFILE         (0x00000003)
#define DFCBM_PROGRESSWORKINGFILE           (0x00000004)
#define DFCBM_BEFOREOPENWORKINGFILEPREPARSE (0x00000005)
#define DFCBM_AFTERCLOSINGWORKINGFILE       (0x00000015)
#define DFCBM_AFTERCLOSINGPREVIOUSFILE      (0x00000016)
#define DFCBM_AFTERCLOSINGDIRECTORY         (0x00000017)
