


typedef struct
{
  FILETOADD *pFileToAdd ;
  dfuLong32 dfNbFileToAdd ;
  dfuLong32 dfFileToAddStepAlloc ;
  dfuLong32 dfNbFileToAddAllocated ;
} FILETOADDARRAY;


#if defined(__cplusplus) && (!defined(ALLINCPP))
extern "C" {
#endif

BOOL SVFAPI ClearFileToAdd(FILETOADD* pfta);
void SVFAPI ClearFileToAddArrayWithDelete(FILETOADDARRAY* pftaArray,BOOL fClearPrevious,BOOL fDeleteOnDisk);
//BOOL BuildFileToAddFromRealFile(FILETOADD &fta,LPCTSTR lpszFileName,LPCSTR lpszAddPreviousDir);
BOOL SVFAPI AddFtaToFtaArray(FILETOADDARRAY* pftaArray,const FILETOADD* pfta,dfuLong32 dfNbAdd);
//BOOL AddFileFtaArray(FILETOADDARRAY* pftaArray,LPCTSTR lpszFileName,LPCSTR lpszAddPreviousDir);

BOOL SVFAPI BuildFtaArrayFromZipfile(FILETOADDARRAY* pftaArray,const char * lpszZipFile);

BOOL SVFAPI BuildFileSetFromZipFile(const char * lpszZipFile,FILESET * pfs,BOOL fSetTempFlag,H_ERROR_INFO* pei);


#if defined(__cplusplus) && (!defined(ALLINCPP))
}
#endif