/* apldifst.h */
/* function and structure to execute a stream patch from two file */


DECLARE_DFHANDLE(HAPPLYDIF_INTERNALSTATE);

typedef struct
{
  dfuLong32 nbOrig;               /* must be initialised before call init */
  ORIGDATAPTR OrigDataPtr;      /* must be initialised before call init */
  dfuLong32 uDoChecksum;          /* 1 if we compute checksum in OutData */


  IN_DATA_STREAM in_data_stream;
  OUT_DATA_STREAM out_data_stream;

  HAPPLYDIF_INTERNALSTATE state;        /* not visible by applications */
}
APPLYDIF_STREAM;

int SVFAPI ApplyDifInit OF((APPLYDIF_STREAM * read_stream));
int SVFAPI ApplyDifInitEx OF((APPLYDIF_STREAM * read_stream, BOOL fComputeChecksum));
int SVFAPI DoApplyDifWork OF((APPLYDIF_STREAM * read_stream));
int SVFAPI CloseApplyDif OF((APPLYDIF_STREAM * read_stream, dfuLong32 * uChecksum));

/****************************************************************************/
